package ovh.herisson.Clyde.Tables.ScientificPublications;

/******************************************************
 * @file ResearchCoAuthors
 * @author Maxime Bartha
 * @scope Extension Publications scientifiques
 *
 * Co-Authors List entity (will be accessed by Articles)
 *
 ******************************************************/
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;

@Getter
@Setter
@NoArgsConstructor
@Entity
public class ResearchCoAuthors {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    Long id;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "Researcher")
    private Researcher coAuthor;

    @ManyToOne(fetch = FetchType.EAGER)
    @OnDelete(action = OnDeleteAction.CASCADE)
    @JoinColumn(name = "Article")
    private Research research;

    public ResearchCoAuthors(Researcher coAuthor, Research research){
        this.coAuthor = coAuthor;
        this.research = research;
    }
}
